Public Class Form1
    ' Return number!
    Private Function Factorial(ByVal number As Long) As Long
        If (number < 0) Then
            Throw New ArgumentOutOfRangeException( _
                "number", "Factorial parameter must be at least 0.")
        End If

        Dim result As Long = 1
        For i As Integer = 1 To number
            result *= i
        Next i

        Return result
    End Function

    ' Display the factorial.
    Private Sub btnCalculateFactorial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculateFactorial.Click
        Try
            txtNFactorial.Text = Factorial(Long.Parse(txtN.Text)).ToString()
        Catch ex As Exception
            MessageBox.Show("Error calculating factorial." _
                & vbCrLf & vbCrLf & ex.Message)
        End Try
    End Sub

    ' Throw a custom exception.
    Private Sub btnThrowCustomException_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnThrowCustomException.Click
        Try
            ThrowCustomException()
        Catch ex As Exception
            MessageBox.Show("Error." _
                & vbCrLf & vbCrLf & ex.Message)
        End Try
    End Sub
    Private Sub ThrowCustomException()
        Throw New InvalidAlgorithmException("Invalid algorithm selected")
    End Sub
End Class
